package com.kingdee.shr.perfweb.app.workflow;

import java.math.BigDecimal;
import java.sql.Timestamp;
import java.util.*;

import com.kingdee.bos.BOSException;
import com.kingdee.bos.Context;
import com.kingdee.bos.metadata.entity.*;
import com.kingdee.bos.metadata.query.util.CompareType;
import com.kingdee.bos.util.BOSUuid;
import com.kingdee.eas.common.EASBizException;
import com.kingdee.eas.framework.CoreBaseCollection;
import com.kingdee.eas.util.app.DbUtil;
import com.kingdee.jdbc.rowset.IRowSet;
import com.kingdee.shr.base.syssetting.app.filter.HRFilterUtils;
import com.kingdee.shr.perfweb.app.base.evalplan.*;
import com.kingdee.shr.perfweb.app.base.evalrule.*;
import com.kingdee.shr.perfweb.app.base.perfmancescore.IPerfScorLevelDefine;
import com.kingdee.shr.perfweb.app.base.perfmancescore.PerfScorLevelDefineCollection;
import com.kingdee.shr.perfweb.app.base.perfmancescore.PerfScorLevelDefineFactory;
import com.kingdee.shr.perfweb.app.base.perfmancescore.PerfScorLevelDefineInfo;
import com.kingdee.shr.perfweb.app.base.perfmancescore.PerfScoreLevelInfo;
import com.kingdee.shr.perfweb.app.common.CustomerDevConfigCollection;
import com.kingdee.shr.perfweb.app.common.CustomerDevConfigFactory;
import com.kingdee.shr.perfweb.app.common.ICustomerDevConfig;
import com.kingdee.shr.perfweb.app.common.YesOrNoEnum;
import com.kingdee.shr.perfweb.app.exception.SHRPerfWebBizException;
import com.kingdee.shr.perfweb.app.resource.SHRPerfWebResource;
import com.kingdee.shr.perfweb.app.workflow.PerfWorkFlowFacadeControllerBean;
import com.kingdee.shr.perfweb.bean.PerfScoreBean;
import com.kingdee.shr.perfweb.bean.PerfScoreList;
import com.kingdee.shr.perfweb.portal.serviceImpl.PerfGoasFillService;
import com.kingdee.shr.perfweb.util.*;
import com.kingdee.shr.perfweb.utils.PerfPlanUtils;
import com.kingdee.shr.perfweb.utils.PerfWorkFlowUtils;
import com.kingdee.shr.perfweb.utils.PerfwebStrUtils;
import com.kingdee.shr.perfweb.workflow.serviceImpl.WorkFlowEngine;
import com.kingdee.shr.perfweb.workflowext.CustomerPerfwebWorkFlowFactory;
import com.kingdee.shr.perfweb.workflowext.ICustomerPerfwebWorkFlow;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.util.CollectionUtils;


/**
 * Ч
 * 20241216
 * @author coyle
 */
public class PerfWorkFlowFacadeControllerBeanEx  extends PerfWorkFlowFacadeControllerBean {
	
	private static final Logger logger = LoggerFactory .getLogger(PerfWorkFlowFacadeControllerBeanEx.class);


 
    public static PerfWorkFlowFacadeControllerBeanEx getInstance() {
        return PerfWorkFlowFacadeControllerBeanEx.PerfWorkFlowFacadeControllerBeanInst.instance;
    }
	
	   public static class PerfWorkFlowFacadeControllerBeanInst {
		   private static final PerfWorkFlowFacadeControllerBeanEx instance = new PerfWorkFlowFacadeControllerBeanEx();
		   public PerfWorkFlowFacadeControllerBeanInst() {
		   }
	   }

	public String saveScore(Context ctx, PerfScoreList scoreList) {
		try {
			String needScore = scoreList.getNeedScore();
			String sumScore = scoreList.getSumScore();
			if (!this.isNodeHandlerValid(ctx, scoreList.getGradeTaskNode())) {
				return ServerResponseConst.INVALID;
			}

			IGradeTargetInst igradeTargetInst = GradeTargetInstFactory.getLocalInstance(ctx);
			CoreBaseCollection gradeTargetCollection = new CoreBaseCollection();
			Map<String, Object> targetValues = new HashMap();
			Set<String> indicatorIdSet = new HashSet(16);
			String scoreOrRate = "";
			Set<String> gradeSet = new HashSet();
			Iterator var11 = scoreList.getScoreList().iterator();

			while(var11.hasNext()) {
				PerfScoreBean scoreBean = (PerfScoreBean)var11.next();
				String sourceIndicator = scoreBean.getIndicatorId();
				String indicatorId = scoreBean.getIndicatorId().substring(0, sourceIndicator.lastIndexOf("Itag0"));
				indicatorIdSet.add(indicatorId);
				targetValues.put(indicatorId, scoreBean);
				scoreOrRate = scoreBean.getScoreOrRate();
				gradeSet.add(scoreBean.getNodeGrade());
			}

			EntityViewInfo evi = new EntityViewInfo();
			FilterInfo filter = new FilterInfo();
			filter.getFilterItems().add(new FilterItemInfo("gradeTaskNode", scoreList.getGradeTaskNode(), CompareType.EQUALS));
			filter.getFilterItems().add(new FilterItemInfo("evaObj", scoreList.getEvaObj(), CompareType.EQUALS));
			filter.getFilterItems().add(new FilterItemInfo("target", indicatorIdSet, CompareType.INCLUDE));
			evi.setFilter(filter);
			SelectorItemCollection indSic = new SelectorItemCollection();
			indSic.add(new SelectorItemInfo("*"));
			indSic.add(new SelectorItemInfo("areaBase.performanceRule"));
			indSic.add(new SelectorItemInfo("areaBase.subAreaType"));
			indSic.add(new SelectorItemInfo("areaBase.id"));
			evi.setSelector(indSic);
			this.updateEditActValues(ctx, targetValues, indicatorIdSet, true);
			Set<String> indicatorTargetIds = new HashSet();
			Set<String> recordTargetIds = new HashSet();
			GradeTargetInstCollection gtInstColl = GradeTargetInstFactory.getLocalInstance(ctx).getGradeTargetInstCollection(evi);
			Map<String, GradeTargetInstInfo> gtInstMap = new HashMap(16);
			String ruleId = "";
			if (null != gtInstColl && gtInstColl.size() > 0) {
				int gtInstSize = gtInstColl.size();

				for(int i = 0; i < gtInstSize; ++i) {
					GradeTargetInstInfo gradeTargetInstInfo = gtInstColl.get(i);
					if (TargetTypeEnum.INDICATOR == gradeTargetInstInfo.getTargetType()) {
						indicatorTargetIds.add(gradeTargetInstInfo.getTarget());
					} else if (TargetTypeEnum.RECORD == gradeTargetInstInfo.getTargetType()) {
						recordTargetIds.add(gradeTargetInstInfo.getTarget());
					}

					gtInstMap.put(gradeTargetInstInfo.getGradeTaskNode().getId().toString() + "#" + gradeTargetInstInfo.getTarget(), gradeTargetInstInfo);
					ruleId = gradeTargetInstInfo.getAreaBase().getPerformanceRule().getId().toString();
				}
			}

			Map<String, IndicatorExtendHelperInfo> targetExtendMap = this.getTargetExtendMapByTargetIds(ctx, indicatorTargetIds, recordTargetIds);
			CoreBaseCollection extendHelperCollection = new CoreBaseCollection();
			Map<String, IndicatorTargetInfo> indicatorTargetInfoMap = new HashMap();
			Map<String, Float> gradeScoreMap = new HashMap();
			if (scoreOrRate.equals("0")) {
				IndicatorTargetCollection indicatorTargetCollection = IndicatorTargetFactory.getLocalInstance(ctx).getIndicatorTargetCollection("select id, qualiOrRation, scoringFormula WHERE ID in (" + PerfwebStrUtils.convertListToString(indicatorIdSet.toArray()) + ")");
				if (indicatorTargetCollection != null && indicatorTargetCollection.size() > 0) {
					indicatorTargetInfoMap = new HashMap(indicatorTargetCollection.size());

					for(int i = 0; i < indicatorTargetCollection.size(); ++i) {
						IndicatorTargetInfo indicatorTargetInfo = indicatorTargetCollection.get(i);
						indicatorTargetInfoMap.put(indicatorTargetInfo.getId().toString(), indicatorTargetInfo);
					}
				}
			} else {
				gradeScoreMap = PerfWorkFlowUtils.getDefaultScoreByPerfRate(ctx, ruleId, gradeSet, "0");
			}

			Iterator var49 = scoreList.getScoreList().iterator();

			String isRejection;
			while(var49.hasNext()) {
				PerfScoreBean scoreBean = (PerfScoreBean)var49.next();
				String sourceIndicator = scoreBean.getIndicatorId();
				String indicatorId = scoreBean.getIndicatorId().substring(0, sourceIndicator.lastIndexOf("Itag0"));
				if (!StringUtils.isEmpty(scoreBean.getScore())) {
					scoreBean.setScore(scoreBean.getScore().trim());
				} else {
					scoreBean.setScore((String)null);
				}

				GradeTargetInstInfo gradeTargetInfo = (GradeTargetInstInfo)gtInstMap.get(scoreList.getGradeTaskNode() + "#" + indicatorId);
				if (null != gradeTargetInfo) {
					if (scoreOrRate.equals("0")) {
						if ("200".equals(gradeTargetInfo.getTargetType().getValue())) {
							IndicatorTargetInfo targetInfo = (IndicatorTargetInfo)indicatorTargetInfoMap.get(indicatorId);
							if (targetInfo != null && (targetInfo.getQualiOrRation().getValue() == 0 || StringUtils.isEmpty(targetInfo.getScoringFormula()) && targetInfo.getQualiOrRation().getValue() == 1)) {
								if (!StringUtils.isEmpty(scoreBean.getScore())) {
									gradeTargetInfo.setTargetScore(Float.parseFloat(scoreBean.getScore()));
								} else {
									gradeTargetInfo.put("targetScore", (Object)null);
								}
							}
						} else if (!StringUtils.isEmpty(scoreBean.getScore())) {
							gradeTargetInfo.setTargetScore(Float.parseFloat(scoreBean.getScore()));
						} else {
							gradeTargetInfo.put("targetScore", (Object)null);
						}
					} else {
						gradeTargetInfo.setGradeRank(scoreBean.getNodeGrade());
						if (gradeTargetInfo.getAreaBase().getId() != null) {
							EvaluFormAreaBaseInfo areaBaseInfo = gradeTargetInfo.getAreaBase();
							if (areaBaseInfo.getPerformanceRule().getId() != null) {
								float score = ((Map)gradeScoreMap).get(scoreBean.getNodeGrade()) == null ? 0.0F : (Float)((Map)gradeScoreMap).get(scoreBean.getNodeGrade());
								if (SubAreaTypeEnum.ADDSUB.equals(areaBaseInfo.getSubAreaType()) && StringUtils.isNotEmpty(scoreBean.getScore())) {
									score = Double.valueOf(scoreBean.getScore()).floatValue();
								}

								gradeTargetInfo.setTargetScore(score);
								scoreBean.setScore(String.valueOf(score));
							}
						}
					}

					gradeTargetInfo.setComment(scoreBean.getComment());
					Map<String, Map<String, String>> extendInfo = scoreBean.getExtendInfo();
					if (!CollectionUtils.isEmpty(extendInfo)) {
						IndicatorExtendHelperInfo extendHelperInfo = null;
						if (!CollectionUtils.isEmpty(targetExtendMap)) {
							extendHelperInfo = (IndicatorExtendHelperInfo)targetExtendMap.get(indicatorId);
							extendHelperCollection.add(extendHelperInfo);
						}

						Iterator var30 = extendInfo.keySet().iterator();

						while(var30.hasNext()) {
							String colName = (String)var30.next();
							if ("0".equals(((Map)extendInfo.get(colName)).get("fillOverwrite"))) {
								gradeTargetInfo.put(colName.substring(1), ((Map)extendInfo.get(colName)).get("value"));
							} else if ("1".equals(((Map)extendInfo.get(colName)).get("fillOverwrite")) && extendHelperInfo != null) {
								extendHelperInfo.put(colName.substring(1), ((Map)extendInfo.get(colName)).get("value"));
							}
						}
					}

					gradeTargetInfo.setScoreStatus(ScoreStatusEnum.JUSTSAVE);
					isRejection = scoreBean.getIsRejection();
					if (!StringUtils.isEmpty(isRejection)) {
						gradeTargetInfo.setIsRejection(YesOrNoEnum.getEnum(Integer.parseInt(isRejection)));
					}

					gradeTargetCollection.add(gradeTargetInfo);
				}
			}

			igradeTargetInst.updateBatchData(gradeTargetCollection);
			if (extendHelperCollection.size() > 0) {
				IndicatorExtendHelperFactory.getLocalInstance(ctx).updateBatchData(extendHelperCollection);
			}
			//
			GradeTaskNodeInstCollection gradeTaskNodeColl = GetEntityInfoUtils.getGradeTaskNodeInstCollection(ctx, scoreList.getGradeTaskNode());
			if (gradeTaskNodeColl != null && gradeTaskNodeColl.size() > 0) {
				GradeTaskNodeInstInfo gTaskNodeInstInfo = gradeTaskNodeColl.get(0);
				List<String> annexList = scoreList.getAnnexList();
				List<String> annexIdList = scoreList.getAnnexIdList();
				String nodeSumscore;
				if (annexList != null) {
					try {
						PerfEvaObjectInfo evaObj = gTaskNodeInstInfo.getEvaObj();
						nodeSumscore = null;
						if (evaObj != null) {
							nodeSumscore = gTaskNodeInstInfo.getEvaObj().getId().toString();
						}

						isRejection = gTaskNodeInstInfo.getId().toString();
						AttachmentUtil.saveAttachments(ctx, nodeSumscore, isRejection, annexList, annexIdList);
					} catch (Exception var40) {
						logger.error("saveAttachments err:" + var40);
					}
				}

				HashMap<String, String> sumscoreMap = this.calcNodeSumScore(ctx, scoreList.getGradeTaskNode(), gTaskNodeInstInfo.getEvaObj().getId().toString());
				nodeSumscore = (String)sumscoreMap.get("sumScore");
				WFNodeDefInfo wfNodeInfo = GetEntityInfoUtils.getWFNodeDefInfo(ctx, gTaskNodeInstInfo.getWfNode().getId().toString());
				String isNeedScore = wfNodeInfo.getNeedScore().getValue();
				//20241213  ,ְֶܷʱı
				if (!StringUtils.isEmpty(sumScore)) {
					if (isNeedScore.equals("0")) {
						gTaskNodeInstInfo.put("nodeSumScore", (Object)null);
					} else {
						gTaskNodeInstInfo.setNodeSumScore(PerfPortalUtils.roudUpRemainGiveDecimal(2, Float.valueOf(sumScore)));
					}
				} else {
					gTaskNodeInstInfo.put("nodeSumScore", (Object)null);
				}

				if (!gTaskNodeInstInfo.getScoreStatus().getValue().equals("2")) {
					gTaskNodeInstInfo.setScoreStatus(ScoreStatusEnum.JUSTSAVE);
				}

				gTaskNodeInstInfo.setTaskStatus(TaskStatusEnum.DEALING);
				boolean gradeCarryToNextFlag = false;
				WFNodeDefCollection wfNodeDefCollection = WFNodeDefFactory.getLocalInstance(ctx).getWFNodeDefCollection("where workflow = '" + wfNodeInfo.getWorkflow().getId().toString() + "' and level =" + (wfNodeInfo.getLevel() - 1));
				String nodeGrade;
				if (wfNodeDefCollection != null && wfNodeDefCollection.size() > 0) {
					int size = wfNodeDefCollection.size();

					for(int i = 0; i < size; ++i) {
						nodeGrade = wfNodeDefCollection.get(i).getGradeCarryToNext();
						if ("1".equals(nodeGrade)) {
							gradeCarryToNextFlag = true;
							break;
						}
					}
				}

				String isManualJudgeGrade = PerfConfigUtils.getConfigByName(ctx, "isManualJudgeGrade", false);
				if (!StringUtils.isEmpty(scoreList.getIsEditGrade()) && scoreList.getIsEditGrade().equals("0") && !gradeCarryToNextFlag || isManualJudgeGrade.equals("0") || isManualJudgeGrade.equals("2")) {
					PerformanceRuleInfo ruleInfo = GetEntityInfoUtils.getPerformanceRuleInfoByEvaObjNew(ctx, gTaskNodeInstInfo.getEvaObj().getId().toString());
					if (!StringUtils.isEmpty(nodeSumscore) && isManualJudgeGrade.equals("2")) {
						nodeGrade = (new PerfGoasFillService()).getCurrentSelectVal(ctx, ruleInfo.getPerfRate().getId().toString(), Float.valueOf(nodeSumscore));
						scoreList.setWholeGrade(nodeGrade);
					}
				}

				if (GradeEvaNeedEnum.NO.equals(wfNodeInfo.getPerfGradeEvaluate())) {
					scoreList.setWholeGrade((String)null);
				}

				if (scoreList.getWholeGrade() != null) {
					gTaskNodeInstInfo.setNodeGrade(scoreList.getWholeGrade());
				} else {
					gTaskNodeInstInfo.setNodeGrade((String)null);
				}

				SelectorItemCollection sic = new SelectorItemCollection();
				sic.add(new SelectorItemInfo("scoreStatus"));
				sic.add(new SelectorItemInfo("nodeSumScore"));
				sic.add(new SelectorItemInfo("taskStatus"));
				sic.add(new SelectorItemInfo("nodeGrade"));
				IGradeTaskNodeInst igradeTaskNodeInst = GradeTaskNodeInstFactory.getLocalInstance(ctx);
				if ("3".equals(needScore) && StringUtils.isNotBlank(sumScore)) {
					gTaskNodeInstInfo.setNodeSumScore(Float.valueOf(sumScore));
				}

				igradeTaskNodeInst.updatePartial(gTaskNodeInstInfo, sic);
				IWholeComment iWholeComment = WholeCommentFactory.getLocalInstance(ctx);
				WholeCommentCollection wholeCommentColl = iWholeComment.getWholeCommentCollection(" where gradeTaskNodeInst='" + gTaskNodeInstInfo.getId().toString() + "'");
				if (wholeCommentColl != null && wholeCommentColl.size() > 0) {
					SelectorItemCollection selector = new SelectorItemCollection();
					selector.add(new SelectorItemInfo("score"));
					selector.add(new SelectorItemInfo("comment"));
					selector.add(new SelectorItemInfo("grade"));
					selector.add(new SelectorItemInfo("isVetoZero"));
					WholeCommentInfo wholeCommentInfo = wholeCommentColl.get(0);
					//20241214
					if (!StringUtils.isEmpty(sumScore)) {
						wholeCommentInfo.setScore(PerfPortalUtils.roudUpRemainGiveDecimal(2, Float.valueOf(sumScore)));
					} else {
						wholeCommentInfo.put("score", (Object)null);
					}

					if (scoreList.getWholeComment() != null) {
						wholeCommentInfo.setComment(scoreList.getWholeComment());
					} else {
						wholeCommentInfo.setComment(wholeCommentInfo.getComment());
					}

					if (scoreList.getWholeGrade() != null) {
						wholeCommentInfo.setGrade(scoreList.getWholeGrade());
					} else {
						wholeCommentInfo.setGrade(wholeCommentInfo.getGrade());
					}

					if (((String)sumscoreMap.get("isVetoZero")).equals("1")) {
						wholeCommentInfo.setIsVetoZero(YesOrNoEnum.YES);
					} else {
						wholeCommentInfo.setIsVetoZero(YesOrNoEnum.NO);
					}

					iWholeComment.updatePartial(wholeCommentInfo, selector);
				}
			}
		} catch (Exception var41) {
			logger.error("PERFWEB-SAVESCOREERR...error message: ", var41);
			this.setRollbackOnly();
			return ServerResponseConst.FAILED;
		}

		return ServerResponseConst.SUCCESS;
	}



	private void updateEditActValues(Context ctx, Map<String, Object> targetValues, Set<String> indicatorIdSet, boolean isSave) throws BOSException, EASBizException {
		Map<String, Boolean> map = PerfPlanUtils.checkCanEditActValue(ctx, indicatorIdSet);
		Map<String, Boolean> auditMap = PerfPlanUtils.checkIsAudit(ctx, indicatorIdSet);
		Map<String, String> indicatorMap = new HashMap();
		IIndicatorTarget iIndicatorTarget = IndicatorTargetFactory.getLocalInstance(ctx);
		CoreBaseCollection colls = new CoreBaseCollection();
		FilterInfo filter = new FilterInfo();
		filter.getFilterItems().add(new FilterItemInfo("id", indicatorIdSet, CompareType.INCLUDE));
		IndicatorTargetCollection targets = iIndicatorTarget.getIndicatorTargetCollection("where " + filter.toSql());
		Set<String> calscore = new HashSet();

		for(int i = 0; i < targets.size(); ++i) {
			String id = targets.get(i).getId().toString();
			IndicatorTargetInfo indicatorTargetInfo = targets.get(i);
			if (map.get(id) != null && (Boolean)map.get(id)) {
				if (!isSave) {
					indicatorTargetInfo.setAchivementEntryState(AchivementDataEntryStateEnum.SUBMITED);
					boolean isAudit = auditMap.get(id) == null ? false : (Boolean)auditMap.get(id);
					if (isAudit) {
						indicatorTargetInfo.setAuditTime(new Timestamp(System.currentTimeMillis()));
						indicatorTargetInfo.setActCompValState(ActCompValStateEnum.ENABLED);
						calscore.add(id);
						indicatorMap.put(id, "");
					}

					String actualCompleValue = indicatorTargetInfo.getActualCompleValue();
					if (StringUtils.isEmpty(actualCompleValue)) {
						indicatorTargetInfo.setAchivementEntryState(AchivementDataEntryStateEnum.SAVED);
						indicatorTargetInfo.setActCompValState(ActCompValStateEnum.UNENABLE);
					}
				} else {
					PerfScoreBean bean = (PerfScoreBean)targetValues.get(id);
					indicatorTargetInfo.setEditActlCompVal(bean.getActValue());
					indicatorTargetInfo.setEditTargetVal(bean.getTargetVale());
					indicatorTargetInfo.setActualCompleValue(bean.getActValue());
					indicatorTargetInfo.setTargetValue(bean.getTargetVale());
					indicatorTargetInfo.setActualCompleteDesc(bean.getDescription());
					if (!StringUtils.isEmpty(bean.getActulCompleteTime())) {
						indicatorTargetInfo.setActualCompleteTime(Timestamp.valueOf(PersonInchargeUtils.strToTimestamp(bean.getActulCompleteTime()) + " 00:00:00"));
					}

					indicatorTargetInfo.put("entrior", HRFilterUtils.getCurrentPersonId(ctx));
					indicatorTargetInfo.setEntryTime(new Timestamp(System.currentTimeMillis()));
					indicatorTargetInfo.setAchivementEntryState(AchivementDataEntryStateEnum.SAVED);
					PersonInchargeUtils.addGoalsProgressRecord(ctx, indicatorTargetInfo);
				}

				colls.add(indicatorTargetInfo);
			}
		}

		iIndicatorTarget.save(colls);
		if (calscore.size() > 0 && !isSave) {
			ScoreFormulaCalculateFacadeFactory.getLocalInstance(ctx).calcalateNodeScore(indicatorMap);
		}

	}




	/************************************************************ύɿ˽**********************************************/

	public String _submitPerfScoreNew(Context ctx, String gradeTaskNode, String evaObj, boolean isAutoSubmit, boolean isAutoGtnNode) throws BOSException, EASBizException {
		if (!isAutoSubmit && !this.isNodeHandlerValid(ctx, gradeTaskNode)) {
			return ServerResponseConst.INVALID;
		} else {
			PerfEvaObjectInfo perfEvaObjectInfo = GetEntityInfoUtils.getPerfEvaObjectInfo(ctx, evaObj);
			boolean isOrg = perfEvaObjectInfo.getIsOrg() != null && perfEvaObjectInfo.getIsOrg().getValue() == 1;
			String isAutoSubmitVal = PerfConfigUtils.getConfigByName(ctx, "isAutoSubmit", isOrg);
			isAutoSubmit = StringUtils.isEmpty(isAutoSubmitVal) ? false : isAutoSubmitVal.equals("true");
			IGradeTaskNodeInst igradeTaskNodeInst = GradeTaskNodeInstFactory.getLocalInstance(ctx);
			GradeTaskNodeInstCollection gradeTaskNodeInstColl = GetEntityInfoUtils.getGradeTaskNodeInstCollection(ctx, gradeTaskNode);
			if (gradeTaskNodeInstColl != null && gradeTaskNodeInstColl.size() > 0) {
				GradeTaskNodeInstInfo gradeTaskNodeInfo = gradeTaskNodeInstColl.get(0);
				float nodeSumScoreTmp = gradeTaskNodeInfo.getNodeSumScore();
				if (IsNeedScoreEnum.EVALUSUMSCORE.equals(gradeTaskNodeInfo.getWfNode().getNeedScore())) {
					gradeTaskNodeInfo.put("nodeSumScore", nodeSumScoreTmp);
				} else {
					String nodeSumscore = null;
					HashMap<String, String> sumscoreMap = this.calcNodeSumScore(ctx, gradeTaskNode, evaObj);
					nodeSumscore = (String)sumscoreMap.get("sumScore");
					if (!StringUtils.isEmpty(nodeSumscore)) {
						//202412 ;
//						gradeTaskNodeInfo.put("nodeSumScore", PerfPortalUtils.roudUpRemainGiveDecimal(2, Float.valueOf(nodeSumscore)));
						gradeTaskNodeInfo.put("nodeSumScore", nodeSumScoreTmp);
					} else {
						gradeTaskNodeInfo.put("nodeSumScore", (Object)null);
					}
				}

				gradeTaskNodeInfo.setScoreStatus(ScoreStatusEnum.SUBMIT);
				gradeTaskNodeInfo.setHandleTime(new Date());
				gradeTaskNodeInfo.setCanEdit(CanEditEnum.DISABLED);
				gradeTaskNodeInfo.setTaskStatus(TaskStatusEnum.COMPLETED);
				gradeTaskNodeInfo.put("concurrentNodeStatus", 1);
				SelectorItemCollection sic = new SelectorItemCollection();
				sic.add(new SelectorItemInfo("scoreStatus"));
				sic.add(new SelectorItemInfo("handleTime"));
				sic.add(new SelectorItemInfo("canEdit"));
				sic.add(new SelectorItemInfo("nodeSumScore"));
				sic.add(new SelectorItemInfo("taskStatus"));
				sic.add(new SelectorItemInfo("concurrentNodeStatus"));
				igradeTaskNodeInst.updatePartial(gradeTaskNodeInfo, sic);
				String wfNode = gradeTaskNodeInfo.getWfNode().getId().toString();
				WFNodeDefInfo nodeDefInfo = GetEntityInfoUtils.getWFNodeDefInfo(ctx, wfNode);
				String scoreControl = nodeDefInfo.getScoreControl().getValue();
				boolean onlyOneIsEffective = true;
				ITargetNode iTargetNode = TargetNodeFactory.getLocalInstance(ctx);
				FilterInfo nodeFilter = new FilterInfo();
				nodeFilter.getFilterItems().add(new FilterItemInfo("evaObj", evaObj, CompareType.EQUALS));
				nodeFilter.getFilterItems().add(new FilterItemInfo("wfNode", nodeDefInfo.getId().toString(), CompareType.EQUALS));
				if (iTargetNode.exists(nodeFilter)) {
					onlyOneIsEffective = false;
				}

				if (scoreControl.equals("1") && onlyOneIsEffective) {
					CoreBaseCollection coreBaseColl = new CoreBaseCollection();
					GradeTaskNodeInstCollection gradeTaskNodeColl = igradeTaskNodeInst.getGradeTaskNodeInstCollection(" where wfNode='" + wfNode + "' and evaObj='" + evaObj + "' and id<>'" + gradeTaskNode + "'");
					if (gradeTaskNodeColl != null && gradeTaskNodeColl.size() > 0) {
						for(int i = 0; i < gradeTaskNodeColl.size(); ++i) {
							GradeTaskNodeInstInfo gradeNodeInfo = gradeTaskNodeColl.get(i);
							gradeNodeInfo.setIsVisible(IsVisibleEnum.HIDDEN);
							gradeNodeInfo.setCanEdit(CanEditEnum.DISABLED);
							gradeNodeInfo.setScoreStatus(ScoreStatusEnum.SUBMIT);
							gradeNodeInfo.setIsEffective(IsEffectiveEnum.INVALID);
							gradeNodeInfo.setTaskStatus(TaskStatusEnum.COMPLETED);
							gradeNodeInfo.put("concurrentNodeStatus", 2);
							coreBaseColl.add(gradeNodeInfo);
						}

						igradeTaskNodeInst.updateBatchData(coreBaseColl);
					}
				}

				int level = gradeTaskNodeInfo.getWfLevel();
				String wfLevelDef = gradeTaskNodeInfo.getWfLevelDef().getId().toString();
				boolean isCurrentLastLevel = WorkFlowEngine.getInstance().judgeCurrentNodeLevelIsCompleted(ctx, evaObj, wfLevelDef);
				boolean isAllNodeSumbit = WorkFlowEngine.getInstance().judgeIsAllNodeSubmitedIgnoreWorkflow(ctx, evaObj);
				++level;
				Set<String> autoSubmitNodeIds = new HashSet();
				if (this.judgeNextNodeIsActive(evaObj, gradeTaskNodeInfo.getId().toString(), gradeTaskNodeInfo.getIsRegrade(), ctx, level)) {
					if (nodeDefInfo.getScoreCarryToNext().equals("1")) {
						this.scoreCarryToNextLevelNew(ctx, gradeTaskNodeInfo, evaObj, level);
					}

					if (!isAllNodeSumbit && isCurrentLastLevel) {
						autoSubmitNodeIds = WorkFlowEngine.getInstance().activeNodeInst(ctx, evaObj, level, nodeDefInfo.getWorkflow().getId().toString(), isAutoSubmit);
						PerfEvaObjectControllerBean.getInstance().urgedSendSuccessfully(ctx, new String[]{evaObj}, 2, nodeDefInfo.getWorkflow().getId().toString());
					}
				}

				if (!isAllNodeSumbit) {
					if (WorkFlowEngine.getInstance().isNodeHandUp(ctx, evaObj, level)) {
						WorkFlowUtils.writeBackWorkFlowStatusForEvaObj(ctx, perfEvaObjectInfo, PerfEvaObjectWFStatusEnum.HANGUP);
					} else {
						WorkFlowUtils.writeBackWorkFlowStatusForEvaObj(ctx, perfEvaObjectInfo, PerfEvaObjectWFStatusEnum.UNDERWAY);
					}
				}

				if (isAllNodeSumbit) {
					this.calcEvaSumScore(ctx, evaObj, gradeTaskNode, EndWayEnum.NOMALWAY, onlyOneIsEffective);
					this.calcEvaObjTargetScore(ctx, evaObj);
					WorkFlowUtils.writeBackWorkFlowStatusForEvaObj(ctx, perfEvaObjectInfo, PerfEvaObjectWFStatusEnum.COMPLETED);
					WorkFlowUtils.writeBackEndWayForEvaObj(ctx, evaObj, EndWayEnum.NOMALWAY);
					if (isOrg) {
						WorkFlowUtils.writeStatusForOrgEvaResult(ctx, evaObj, PerfEvaObjectWFStatusEnum.COMPLETED);
					} else {
						WorkFlowUtils.writeBackWorkFlowStatusForEvaResult(ctx, evaObj, PerfEvaObjectWFStatusEnum.COMPLETED);
					}
				}

				if (!CollectionUtils.isEmpty((Collection)autoSubmitNodeIds)) {
					Iterator var25 = ((Set)autoSubmitNodeIds).iterator();

					while(var25.hasNext()) {
						String autoSubmitNodeId = (String)var25.next();
						getInstance().submitPerfScoreNew(ctx, autoSubmitNodeId, evaObj, isAutoSubmit, true);
					}
				}

				Set<String> indicatorIdSet = new HashSet();
				GradeTargetInstCollection targetInst = GradeTargetInstFactory.getLocalInstance(ctx).getGradeTargetInstCollection("where gradeTaskNode = '" + gradeTaskNodeInfo.getId().toString() + "'");
				if (targetInst.size() > 0) {
					for(int i = 0; i < targetInst.size(); ++i) {
						GradeTargetInstInfo instInfo = targetInst.get(i);
						if ("200".equals(instInfo.getTargetType().getValue())) {
							indicatorIdSet.add(instInfo.getTarget());
						}
					}
				}

				this.updateEditActValues(ctx, (Map)null, indicatorIdSet, false);
			}

			return ServerResponseConst.SUCCESS;
		}
	}



	private Boolean judgeNextNodeIsActive(String objID, String currentNode, YesOrNoEnum isReGrade, Context ctx, int level) throws BOSException {
		EntityViewInfo viewInfo = new EntityViewInfo();
		FilterInfo filterInfo = new FilterInfo();
		filterInfo.getFilterItems().add(new FilterItemInfo("evaObj", objID, CompareType.EQUALS));
		filterInfo.getFilterItems().add(new FilterItemInfo("id", currentNode, CompareType.NOTEQUALS));
		filterInfo.getFilterItems().add(new FilterItemInfo("wfLevel", level, CompareType.EQUALS));
		viewInfo.setFilter(filterInfo);
		SelectorItemCollection selector = viewInfo.getSelector();
		selector.add("id");
		selector.add("wfLevel");
		selector.add("taskStatus");
		selector.add("scoreStatus");
		selector.add("isEffective");
		GradeTaskNodeInstCollection nodeInstCollection = GradeTaskNodeInstFactory.getLocalInstance(ctx).getGradeTaskNodeInstCollection(viewInfo);
		if (isReGrade == YesOrNoEnum.NO) {
			return true;
		} else {
			for(int i = 0; i < nodeInstCollection.size(); ++i) {
				GradeTaskNodeInstInfo taskNodeInst = nodeInstCollection.get(i);
				if (taskNodeInst.getTaskStatus() == TaskStatusEnum.UNDEAL || taskNodeInst.getTaskStatus() == TaskStatusEnum.DEALING) {
					return true;
				}
			}

			return false;
		}
	}

	public String calcEvaSumScore(Context ctx, String evaObj, String gradeTaskNode, EndWayEnum endWay, boolean onlyOneIsEffective) throws BOSException {
		String sumScore = null;
		String nodeGrade = null;
		BigDecimal sumScoreMal = BigDecimal.ZERO;
		boolean hasFinalGrade = false;
		boolean hasSetScoreHandler = false;
		Map<String, Integer> nodeEffectiveHandlerCountMap = new HashMap(16);

		try {
			IGradeTaskNodeInst iGradeTaskNodeInst = GradeTaskNodeInstFactory.getLocalInstance(ctx);
			PerfEvaObjectInfo evaObjInfo = GetEntityInfoUtils.getPerfEvaObjectInfo(ctx, evaObj);
			boolean isMatrixEvalu = evaObjInfo.getCanAdjustEvaluer().getValue() == 1;
			boolean isTargetNodeWeight = evaObjInfo.getPeriod().getPerfPlan().isTargetNodeWeight();
			Set<String> wfNodeHasTargetNodes = new HashSet();
			TargetNodeCollection targetNodes = TargetNodeFactory.getLocalInstance(ctx).getTargetNodeCollection("select wfNode where evaObj ='" + evaObj + "'");
			if (targetNodes != null && !targetNodes.isEmpty()) {
				Iterator<TargetNodeInfo> it = targetNodes.iterator();

				while(it.hasNext()) {
					TargetNodeInfo targetNodeInfo = (TargetNodeInfo)it.next();
					wfNodeHasTargetNodes.add(targetNodeInfo.getWfNode().getId().toString());
				}
			}

			GradeTaskNodeInstCollection gradeTNodeInstColl = iGradeTaskNodeInst.getGradeTaskNodeInstCollection(" where evaObj='" + evaObj + "' and scoreStatus='" + "2" + "' and isEffective='" + "1" + "'");
			ICustomerDevConfig icusDevConfig = CustomerDevConfigFactory.getLocalInstance(ctx);
			CustomerDevConfigCollection cusDevConfigColl = icusDevConfig.getCustomerDevConfigCollection(" where bizType=2 and isStart=1");
			ICustomerPerfwebWorkFlow instance;
			if (!cusDevConfigColl.isEmpty()) {
				instance = CustomerPerfwebWorkFlowFactory.getInstance(ctx, 2);
				sumScore = instance.getCustomerCalcuSumscore(ctx, evaObj);
				return sumScore;
			} else {
				cusDevConfigColl = icusDevConfig.getCustomerDevConfigCollection(" where bizType=1 and isStart=1");
				if (!cusDevConfigColl.isEmpty()) {
					instance = CustomerPerfwebWorkFlowFactory.getInstance(ctx, 1);
					instance.getCustomerCalculateParams(ctx, nodeEffectiveHandlerCountMap, gradeTNodeInstColl, evaObj);
				} else if (!isMatrixEvalu) {
					StringBuffer selectSqlSb = new StringBuffer("select count(FWFNODEID) as nodeCount,FWFNODEID from T_EVA_GRADETASKNODEINST where FEVAOBJID ='");
					selectSqlSb.append(evaObj).append("' and FScoreStatus in ('").append("2").append("','").append("4").append("') and FISEFFECTIVE ='").append("1").append("' group by FWFNODEID");
					IRowSet rs = DbUtil.executeQuery(ctx, selectSqlSb.toString());

					while(rs.next()) {
						nodeEffectiveHandlerCountMap.put(rs.getString("FWFNODEID"), rs.getInt("nodeCount"));
					}
				}

				boolean setFinalGrade = false;
				int isOrg;
				if (gradeTNodeInstColl != null && gradeTNodeInstColl.size() > 0) {
					int gradeTNodeSize = gradeTNodeInstColl.size();

					for(isOrg = 0; isOrg < gradeTNodeSize; ++isOrg) {
						GradeTaskNodeInstInfo gradeTNodeInfo = gradeTNodeInstColl.get(isOrg);
						String wfNode = gradeTNodeInfo.getWfNode().getId().toString();
						String currentTaskNode = gradeTNodeInfo.getId().toString();
						StringBuffer gradeTaskNodeConditionSb = new StringBuffer("select id where wfNode='");
						gradeTaskNodeConditionSb.append(wfNode).append("' and scoreStatus='").append("2").append("' and isEffective='").append("1").append("' and evaObj='" + evaObj + "'");
						int nodeEffectiveHandlerCount = 0;
						if (!isMatrixEvalu && null != nodeEffectiveHandlerCountMap.get(wfNode)) {
							nodeEffectiveHandlerCount = (Integer)nodeEffectiveHandlerCountMap.get(wfNode);
						}

						WFNodeDefInfo nodeDefInfo = GetEntityInfoUtils.getWFNodeDefInfo(ctx, wfNode);
						if (isMatrixEvalu && !hasFinalGrade) {
							if (Integer.valueOf(nodeDefInfo.getIsFinalGrade()) == 1 && gradeTNodeInfo.getIsEndProcess().getValue() == 0 && gradeTNodeInfo.getIsShowWholeGrade().getValue() == 1) {
								hasFinalGrade = true;
							}
						} else if (!hasFinalGrade && Integer.valueOf(nodeDefInfo.getIsFinalGrade()) == 1 && gradeTNodeInfo.getIsEndProcess().getValue() == 0) {
							hasFinalGrade = true;
						}

						if (!setFinalGrade && nodeDefInfo.getPerfGradeEvaluate() != null && nodeDefInfo.getPerfGradeEvaluate().getValue().equals("1")) {
							setFinalGrade = true;
						}

						String scoreControl = nodeDefInfo.getScoreControl().getValue();
						if (null != gradeTNodeInfo.get("nodeSumScore")) {
							float nodeWeight = gradeTNodeInfo.getNodeWeight() / 100.0F;
							float nodeSumScore = gradeTNodeInfo.getNodeSumScore();
							if (!StringUtils.isEmpty(gradeTNodeInfo.getInweight())) {
								nodeWeight += Float.valueOf(gradeTNodeInfo.getInweight()) / 100.0F;
							}

							if (!StringUtils.isEmpty(gradeTNodeInfo.getOutWeight())) {
								nodeWeight = 0.0F;
							}

							onlyOneIsEffective = !wfNodeHasTargetNodes.contains(gradeTNodeInfo.getWfNode().getId().toString());
							hasSetScoreHandler = wfNodeHasTargetNodes.contains(gradeTNodeInfo.getWfNode().getId().toString());
							int effectedCount;
							GradeTaskNodeInstCollection gradeTaskNodeColl;
							int gtnSize;
							ArrayList gradeTasknodeList;
							int k;
							IGradeTargetInst iGradeTargetInst;
							GradeTargetInstCollection targetInstColls;
							BigDecimal reCalNodeSumScore;
							String taskIdCondition;
							if (null != sumScore) {
								if (isMatrixEvalu) {
									if ((!scoreControl.equals("0") || hasSetScoreHandler) && onlyOneIsEffective) {
										sumScore = String.valueOf(Float.valueOf(sumScore) + nodeSumScore * nodeWeight);
									} else {
										effectedCount = 1;
										gradeTaskNodeColl = iGradeTaskNodeInst.getGradeTaskNodeInstCollection(gradeTaskNodeConditionSb.toString());
										if (null != gradeTaskNodeColl && gradeTaskNodeColl.size() > 0) {
											gtnSize = gradeTaskNodeColl.size();
											gradeTasknodeList = new ArrayList();

											for(k = 0; k < gtnSize; ++k) {
												gradeTasknodeList.add(gradeTaskNodeColl.get(k).getId().toString());
											}

											taskIdCondition = "where gradeTaskNode in (" + PerfwebStrUtils.convertListToString(gradeTasknodeList) + ") and nodeTargetWeight='100'";
											iGradeTargetInst = GradeTargetInstFactory.getLocalInstance(ctx);
											if (!onlyOneIsEffective) {
												taskIdCondition = "where gradeTaskNode in (" + PerfwebStrUtils.convertListToString(gradeTasknodeList) + ") ";
												taskIdCondition = taskIdCondition + " and areaBase.subAreaType = '0' and areaBase.areaAddSub = 0 ";
												targetInstColls = iGradeTargetInst.getGradeTargetInstCollection(taskIdCondition);
												reCalNodeSumScore = getReCalNodeSumScore(ctx, currentTaskNode, targetInstColls, isTargetNodeWeight);
												sumScore = String.valueOf((new BigDecimal(sumScore)).add(reCalNodeSumScore.multiply(BigDecimal.valueOf((double)nodeWeight))));
											} else {
												if (iGradeTargetInst.exists(taskIdCondition)) {
													effectedCount = gtnSize;
												}

												sumScore = String.valueOf(Float.valueOf(sumScore) + nodeSumScore * nodeWeight / (float)effectedCount);
											}
										}
									}
								} else if ((scoreControl.equals("0") && !hasSetScoreHandler || !onlyOneIsEffective && isTargetNodeWeight) && nodeEffectiveHandlerCount > 0) {
									sumScore = String.valueOf(Float.valueOf(sumScore) + nodeSumScore * nodeWeight / (float)nodeEffectiveHandlerCount);
								} else {
									sumScore = String.valueOf(Float.valueOf(sumScore) + nodeSumScore * nodeWeight);
								}
							} else if (isMatrixEvalu) {
								if ((!scoreControl.equals("0") || hasSetScoreHandler) && onlyOneIsEffective) {
									sumScore = String.valueOf(nodeSumScore * nodeWeight);
								} else {
									effectedCount = 1;
									gradeTaskNodeColl = iGradeTaskNodeInst.getGradeTaskNodeInstCollection(gradeTaskNodeConditionSb.toString());
									if (null != gradeTaskNodeColl && gradeTaskNodeColl.size() > 0) {
										gtnSize = gradeTaskNodeColl.size();
										gradeTasknodeList = new ArrayList();

										for(k = 0; k < gtnSize; ++k) {
											gradeTasknodeList.add(gradeTaskNodeColl.get(k).getId().toString());
										}

										taskIdCondition = "where gradeTaskNode in (" + PerfwebStrUtils.convertListToString(gradeTasknodeList) + ") and nodeTargetWeight='100'";
										iGradeTargetInst = GradeTargetInstFactory.getLocalInstance(ctx);
										if (!onlyOneIsEffective) {
											taskIdCondition = "where gradeTaskNode in (" + PerfwebStrUtils.convertListToString(gradeTasknodeList) + ") ";
											taskIdCondition = taskIdCondition + " and areaBase.subAreaType = '0' and areaBase.areaAddSub = 0 ";
											targetInstColls = iGradeTargetInst.getGradeTargetInstCollection(taskIdCondition);
											reCalNodeSumScore = this.getReCalNodeSumScore(ctx, currentTaskNode, targetInstColls, isTargetNodeWeight);
											sumScore = String.valueOf(reCalNodeSumScore.multiply(BigDecimal.valueOf((double)nodeWeight)));
										} else {
											if (iGradeTargetInst.exists(taskIdCondition)) {
												effectedCount = gtnSize;
											}

											sumScore = String.valueOf(nodeSumScore * nodeWeight / (float)effectedCount);
										}
									}
								}
							} else if ((scoreControl.equals("0") && !hasSetScoreHandler || !onlyOneIsEffective && isTargetNodeWeight) && nodeEffectiveHandlerCount > 0) {
								sumScore = String.valueOf(nodeSumScore * nodeWeight / (float)nodeEffectiveHandlerCount);
							} else {
								sumScore = String.valueOf(nodeSumScore * nodeWeight);
							}
						}
					}
				}

				PerfEvaObjectInfo perfEvaObjectInfo = GetEntityInfoUtils.getPerfEvaObjectInfo(ctx, evaObj);
				if (null != perfEvaObjectInfo) {
					isOrg = perfEvaObjectInfo.getIsOrg().getValue();
					if (isMatrixEvalu && !onlyOneIsEffective) {
						sumScore = this.checkSumScoreByAddSubArea(ctx, sumScore, evaObj, isOrg);
					}

					if (1 == isOrg) {
						sumScore = this.setOrgLevel(ctx, sumScore, hasFinalGrade, setFinalGrade, perfEvaObjectInfo);
					} else {
						//20241216 -
						IWholeComment whoIns = WholeCommentFactory.getLocalInstance(ctx);
						WholeCommentCollection wholeCommentColl = whoIns.getWholeCommentCollection(" where evaObj = '" + evaObj + "'");
						//
						sumScoreMal = BigDecimal.ZERO;
						String cusGrade = "";
						for(int i = 0; i < wholeCommentColl.size(); i++){
							WholeCommentInfo wComInfo = wholeCommentColl.get(i);
							float score = wComInfo.getScore();
							String  weight = StringUtils.isBlank(wComInfo.getWeight()) ? "0" : wComInfo.getWeight();
							BigDecimal weightDmal =  new BigDecimal(weight);
							//weightתΪ BigDecimal
							if( weightDmal.compareTo(BigDecimal.ZERO) != 0  ){
								sumScoreMal = sumScoreMal.add(new BigDecimal(score).multiply(weightDmal).divide(new BigDecimal(100), 2, BigDecimal.ROUND_HALF_UP));
							}
							
							if(weightDmal.compareTo(new BigDecimal("100")) == 0) {
								cusGrade = StringUtils.isBlank (wComInfo.getGrade()) ? "" : wComInfo.getGrade();
							}
						}
						logger.error (":"+sumScore);
						sumScore = sumScoreMal.toString();
						sumScore = this.setPersonLevel(ctx, sumScore,cusGrade, hasFinalGrade, setFinalGrade, perfEvaObjectInfo);
						logger.error ("2:"+sumScore);
					}
				}
				return sumScore;
			}


		} catch (Exception var40) {
			logger.error(var40.getMessage(), var40);
			logger.error("it is failed to create evaResultevaObj" + evaObj + ",gradeTaskNode" + gradeTaskNode + "");
			throw new BOSException((new SHRPerfWebBizException(SHRPerfWebBizException.CREATEEVARESULTERR)).getMessage());
		}
	}

	private BigDecimal getReCalNodeSumScore(Context ctx, String gradeTaskNode, GradeTargetInstCollection targetInstColls, boolean isTargetNodeWeight) throws BOSException {
		BigDecimal reCalNodeSumScore = BigDecimal.ZERO;
		if (targetInstColls != null && !targetInstColls.isEmpty()) {
			Map<String, Map<String, List<GradeTargetInstInfo>>> targetInstMap = new HashMap();
			Iterator<GradeTargetInstInfo> it = targetInstColls.iterator();

			while(it.hasNext()) {
				GradeTargetInstInfo targetInstInfo = (GradeTargetInstInfo)it.next();
				String key = targetInstInfo.getTarget();
				Map<String, List<GradeTargetInstInfo>> targetInfos = (Map)targetInstMap.get(key);
				String gradeTaskNodeId = targetInstInfo.getGradeTaskNode().getId().toString();
				if (targetInfos == null) {
					targetInfos = new HashMap();
				}

				if (((Map)targetInfos).get(gradeTaskNodeId) == null) {
					List<GradeTargetInstInfo> targetInfo = new ArrayList();
					((Map)targetInfos).put(gradeTaskNodeId, targetInfo);
				}

				((List)((Map)targetInfos).get(gradeTaskNodeId)).add(targetInstInfo);
				targetInstMap.put(key, targetInfos);
			}

			Map<String, BigDecimal> targetWeightMap = new HashMap();
			FilterInfo filterInfo = new FilterInfo();
			filterInfo.getFilterItems().add(new FilterItemInfo("id", targetInstMap.keySet(), CompareType.INCLUDE));
			SelectorItemCollection selectors = new SelectorItemCollection();
			selectors.add(new SelectorItemInfo("id"));
			selectors.add(new SelectorItemInfo("weight"));
			EntityViewInfo evi = new EntityViewInfo();
			evi.setFilter(filterInfo);
			evi.setSelector(selectors);
			IndicatorTargetCollection targetColls = IndicatorTargetFactory.getLocalInstance(ctx).getIndicatorTargetCollection(evi);
			if (targetColls != null && !targetColls.isEmpty()) {
				Iterator<IndicatorTargetInfo> it1 = targetColls.iterator();

				while(it1.hasNext()) {
					IndicatorTargetInfo indicatorTargetInfo = (IndicatorTargetInfo)it1.next();
					String weight = indicatorTargetInfo.getWeight();
					targetWeightMap.put(indicatorTargetInfo.getId().toString(), StringUtils.isEmpty(weight) ? BigDecimal.valueOf(100L) : new BigDecimal(weight));
				}
			}

			RecordTargetCollection recordTargetColls = RecordTargetFactory.getLocalInstance(ctx).getRecordTargetCollection(evi);
			Iterator it1;
			if (recordTargetColls != null && !recordTargetColls.isEmpty()) {
				it1 = recordTargetColls.iterator();

				while(it1.hasNext()) {
					RecordTargetInfo recordTargetInfo = (RecordTargetInfo)it1.next();
					String weight = recordTargetInfo.getWeight();
					targetWeightMap.put(recordTargetInfo.getId().toString(), StringUtils.isEmpty(weight) ? BigDecimal.valueOf(100L) : new BigDecimal(weight));
				}
			}

			it1 = targetInstMap.entrySet().iterator();

			while(true) {
				int nodeSize;
				List currentTargetInsts;
				BigDecimal totalWeight;
				Map.Entry item;
				do {
					if (!it1.hasNext()) {
						return reCalNodeSumScore;
					}

					item = (Map.Entry)it1.next();
					Map<String, List<GradeTargetInstInfo>> targetInsts = (Map)item.getValue();
					nodeSize = targetInsts.size();
					currentTargetInsts = (List)targetInsts.get(gradeTaskNode);
					totalWeight = BigDecimal.ZERO;
					Set<Map.Entry<String, List<GradeTargetInstInfo>>> entries = targetInsts.entrySet();
					Iterator var20 = entries.iterator();

					while(var20.hasNext()) {
						Map.Entry<String, List<GradeTargetInstInfo>> en = (Map.Entry)var20.next();
						List<GradeTargetInstInfo> gtValues = (List)en.getValue();
						Iterator var23 = gtValues.iterator();

						while(var23.hasNext()) {
							GradeTargetInstInfo gt = (GradeTargetInstInfo)var23.next();
							if (StringUtils.isNotEmpty(gt.getNodeTargetWeight())) {
								totalWeight = totalWeight.add(new BigDecimal(gt.getNodeTargetWeight()));
							}
						}
					}
				} while(CollectionUtils.isEmpty(currentTargetInsts));

				String targetId = (String)item.getKey();
				Iterator var37 = currentTargetInsts.iterator();

				while(var37.hasNext()) {
					GradeTargetInstInfo currentTargetInst = (GradeTargetInstInfo)var37.next();
					if (isTargetNodeWeight) {
						reCalNodeSumScore = reCalNodeSumScore.add(BigDecimal.valueOf((double)currentTargetInst.getTargetScore()).multiply((BigDecimal)targetWeightMap.get(targetId)).divide(BigDecimal.valueOf(100L), 4, 4).divide(BigDecimal.valueOf((long)nodeSize), 4, 4));
					} else {
						BigDecimal handlerSize = new BigDecimal(1);
						if (totalWeight.compareTo(new BigDecimal(100)) > 0) {
							handlerSize = totalWeight.divide(BigDecimal.valueOf(100L), 4, 4);
						}

						reCalNodeSumScore = reCalNodeSumScore.add(BigDecimal.valueOf((double)currentTargetInst.getTargetScore()).divide(handlerSize, 4, 4).multiply((BigDecimal)targetWeightMap.get(targetId)).multiply(new BigDecimal(currentTargetInst.getNodeTargetWeight())).divide(BigDecimal.valueOf(10000L), 4, 4));
					}
				}
			}
		} else {
			return reCalNodeSumScore;
		}
	}


	private String checkSumScoreByAddSubArea(Context ctx, String sumScore, String evaObj, int isOrg) throws BOSException, EASBizException {
		IGradeTargetInst iGradeTargetInst = GradeTargetInstFactory.getLocalInstance(ctx);
		GradeTargetInstCollection gradeTargetInstColl = iGradeTargetInst.getGradeTargetInstCollection("select targetScore, gradeTaskNode.nodeWeight, areaBase.* where evaObj='" + evaObj + "' and areaBase.subAreaType = '1' and (areaBase.areaAddSub = 1 or areaBase.targetAddSub = 1)");
		if (gradeTargetInstColl != null && gradeTargetInstColl.size() > 0) {
			Map<String, List<GradeTargetInstInfo>> needCheckTargetMap = new HashMap();

			String areaBaseId;
			for(int i = 0; i < gradeTargetInstColl.size(); ++i) {
				GradeTargetInstInfo gradeTargetInstInfo = gradeTargetInstColl.get(i);
				areaBaseId = gradeTargetInstInfo.getAreaBase().getId().toString();
				List<GradeTargetInstInfo> gradeTargetInstInfos = (List)needCheckTargetMap.get(areaBaseId);
				if (CollectionUtils.isEmpty((Collection)gradeTargetInstInfos)) {
					gradeTargetInstInfos = new ArrayList();
				}

				((List)gradeTargetInstInfos).add(gradeTargetInstInfo);
				needCheckTargetMap.put(areaBaseId, gradeTargetInstInfos);
			}

			BigDecimal totalScore = BigDecimal.ZERO;
			Iterator var22 = needCheckTargetMap.keySet().iterator();

			while(var22.hasNext()) {
				areaBaseId = (String)var22.next();
				List<GradeTargetInstInfo> gradeTargetInstInfos = (List)needCheckTargetMap.get(areaBaseId);
				String areaAddSubUpStr = ((GradeTargetInstInfo)gradeTargetInstInfos.get(0)).getAreaBase().getAreaAddSubUp();
				String areaAddSubDownStr = ((GradeTargetInstInfo)gradeTargetInstInfos.get(0)).getAreaBase().getAreaAddSubDown();
				BigDecimal areaAddSubUp = new BigDecimal(StringUtils.isEmpty(areaAddSubUpStr) ? String.valueOf(Integer.MAX_VALUE) : areaAddSubUpStr);
				BigDecimal areaAddSubDown = new BigDecimal(StringUtils.isEmpty(areaAddSubDownStr) ? String.valueOf(Integer.MIN_VALUE) : areaAddSubDownStr);
				BigDecimal addSubSumScore = BigDecimal.ZERO;

				float nodeWeight;
				float targetScore;
				for(Iterator var17 = gradeTargetInstInfos.iterator(); var17.hasNext(); addSubSumScore = addSubSumScore.add((new BigDecimal(String.valueOf(targetScore))).multiply((new BigDecimal(String.valueOf(nodeWeight))).divide(new BigDecimal("100"))))) {
					GradeTargetInstInfo gradeTargetInstInfo = (GradeTargetInstInfo)var17.next();
					nodeWeight = gradeTargetInstInfo.getGradeTaskNode().getNodeWeight();
					targetScore = gradeTargetInstInfo.getTargetScore();
				}

				if (areaAddSubUp.compareTo(addSubSumScore) < 0) {
					totalScore = totalScore.add(areaAddSubUp);
				} else if (areaAddSubDown.compareTo(addSubSumScore) > 0) {
					totalScore = totalScore.add(areaAddSubDown);
				} else {
					totalScore = totalScore.add(addSubSumScore);
				}
			}

			if (totalScore.compareTo(BigDecimal.ZERO) != 0) {
				IEvaResultSumRevisionLog iEvaResultSumRevisionLog = EvaResultSumRevisionLogFactory.getLocalInstance(ctx);
				EvaResultSumRevisionLogInfo logInfo = new EvaResultSumRevisionLogInfo();
				logInfo.setBeforeReviseSumScore(Double.parseDouble(sumScore));
				sumScore = totalScore.add(new BigDecimal(sumScore)).toString();
				logInfo.setAfterReviseSumScore(Double.parseDouble(sumScore));
				logInfo.setSourceEnum(EvaResultSumLogSourceEnum.AUTOREVISE);
				logInfo.setReviseReason(SHRPerfWebResourceUtil.getRes(SHRPerfWebResource.SYSTEMAUTOREVISESUMSCORE, ctx));
				if (1 == isOrg) {
					IOrgEvaResultSummary iOrgEvaResultSummary = OrgEvaResultSummaryFactory.getLocalInstance(ctx);
					logInfo.setOrgEvaResultSummary(iOrgEvaResultSummary.getOrgEvaResultSummaryInfo(" where evaObj = '" + evaObj + "'"));
				} else {
					IEvaResultSummary iEvaResultSummary = EvaResultSummaryFactory.getLocalInstance(ctx);
					logInfo.setEvaResultSummary(iEvaResultSummary.getEvaResultSummaryInfo(" where evaObj = '" + evaObj + "'"));
				}

				logInfo.setCreateTime(new Timestamp((new Date()).getTime()));
				logInfo.setLastUpdateTime(new Timestamp((new Date()).getTime()));
				iEvaResultSumRevisionLog.save(logInfo);
			}
		}

		return sumScore;
	}



	private String setOrgLevel(Context ctx, String sumScore, boolean hasFinalGrade, boolean setFinalGrade, PerfEvaObjectInfo perfEvaObjectInfo) throws BOSException, EASBizException {
		String evaObj = perfEvaObjectInfo.getId().toString();
		EndWayEnum endWay = EndWayEnum.NOMALWAY;
		boolean isMatrixEvalu = perfEvaObjectInfo.getCanAdjustEvaluer().getValue() == 1;
		String perfPeriod = perfEvaObjectInfo.getPeriod().getId().toString();
		PerfPeriodInfo periodInfo = GetEntityInfoUtils.getPerfPeriodInfo(ctx, perfPeriod);
		PerfPlanInfo planInfo = GetEntityInfoUtils.getPerfPlanInfo(ctx, periodInfo.getPerfPlan().getId().toString());
		IOrgEvaResultSummary ievaResultSummary = OrgEvaResultSummaryFactory.getLocalInstance(ctx);
		new OrgEvaResultSummaryInfo();
		boolean existsFlag = ievaResultSummary.exists(" where evaObj='" + evaObj + "'");
		if (existsFlag) {
			SelectorItemCollection sic = new SelectorItemCollection();
			sic.add(new SelectorItemInfo("sumScore"));
			sic.add(new SelectorItemInfo("gradeLevel"));
			sic.add(new SelectorItemInfo("perfScorLevelDefine"));
			sic.add(new SelectorItemInfo("perfScorLevel"));
			OrgEvaResultSummaryInfo evaResultSummaryInfo = ievaResultSummary.getOrgEvaResultSummaryInfo(" where evaObj='" + evaObj + "'");
			String nodeGrade;
			if ((endWay == EndWayEnum.ENDPROCESS || endWay == EndWayEnum.ENDPERIOD) && !hasFinalGrade) {
				sumScore = null;
				nodeGrade = null;
			} else if (planInfo.getPerfRule().getId() != null) {
				String ruleId = planInfo.getPerfRule().getId().toString();
				WFNodeDefCollection wfNodeDefColl = GetEntityInfoUtils.getFinalGradeNodeColl(ctx, evaObj);
				if (null != wfNodeDefColl && wfNodeDefColl.size() > 0 && wfNodeDefColl.size() < 2) {
					if (isMatrixEvalu) {
						nodeGrade = WorkFlowEngine.getInstance().getMatrixWFNodeWholeGrade(ctx, evaObj, wfNodeDefColl.get(0));
					} else {
						nodeGrade = WorkFlowEngine.getInstance().getWFNodeWholeGrade(ctx, evaObj, wfNodeDefColl.get(0));
					}
				} else {
					nodeGrade = null;
				}

				if (StringUtils.isEmpty(nodeGrade) && null != sumScore) {
					nodeGrade = PerfWorkFlowUtils.getLevelByPerfScore(ctx, ruleId, Float.valueOf(sumScore), "1");
				}

				evaResultSummaryInfo.setGradeLevel(nodeGrade);
			}

			PerfEvaObjRejectionAreaCollection evaObjRejectionAreaColl = GetEntityInfoUtils.getPerfEvaObjRejectionAreaColl(ctx, evaObj);
			if (null != evaObjRejectionAreaColl && evaObjRejectionAreaColl.size() > 0) {
				int evaObjRejSize = evaObjRejectionAreaColl.size();

				for(int i = 0; i < evaObjRejSize; ++i) {
					if (evaObjRejectionAreaColl.get(i).getRejection() != null && evaObjRejectionAreaColl.get(i).getRejection().getValue().equals("100")) {
						sumScore = "0";
						String ruleId = planInfo.getPerfRule().getId().toString();
						nodeGrade = PerfWorkFlowUtils.getLevelByPerfScore(ctx, ruleId, Float.valueOf(sumScore), "1");
						evaResultSummaryInfo.setGradeLevel(nodeGrade);
						break;
					}
				}
			}

			if (null != sumScore) {
				evaResultSummaryInfo.put("sumScore", PerfPortalUtils.roudUpRemainGiveDecimal(2, Float.valueOf(sumScore)));
			} else {
				evaResultSummaryInfo.put("sumScore", (Object)null);
			}

			evaResultSummaryInfo = PerfWorkFlowUtils.setPerfscoreLevelForEvaresult(ctx, evaObj, evaResultSummaryInfo);
			if (!setFinalGrade) {
				evaResultSummaryInfo.setGradeLevel("");
				evaResultSummaryInfo.put("gradeLevel", "");
			}

			ievaResultSummary.updatePartial(evaResultSummaryInfo, sic);
		} else {
			this.createEvaResultSummary(ctx, evaObj);
		}

		return sumScore;
	}



	private String setPersonLevel(Context ctx, String sumScore,String cusGrade, boolean hasFinalGrade, boolean setFinalGrade, PerfEvaObjectInfo perfEvaObjectInfo) throws BOSException, EASBizException {
		String newSumScore = sumScore;
		String evaObj = perfEvaObjectInfo.getId().toString();
		EndWayEnum endWay = EndWayEnum.NOMALWAY;
		boolean isMatrixEvalu = perfEvaObjectInfo.getCanAdjustEvaluer().getValue() == 1;
		String perfPeriod = perfEvaObjectInfo.getPeriod().getId().toString();
		PerfPeriodInfo periodInfo = GetEntityInfoUtils.getPerfPeriodInfo(ctx, perfPeriod);
		PerfPlanInfo planInfo = GetEntityInfoUtils.getPerfPlanInfo(ctx, periodInfo.getPerfPlan().getId().toString());
		IEvaResultSummary ievaResultSummary = EvaResultSummaryFactory.getLocalInstance(ctx);
		new EvaResultSummaryInfo();
		boolean existsFlag = ievaResultSummary.exists(" where evaObj='" + evaObj + "'");
		if (existsFlag) {
			SelectorItemCollection sic = new SelectorItemCollection();
			sic.add(new SelectorItemInfo("sumScore"));
			sic.add(new SelectorItemInfo("gradeLevel"));
			sic.add(new SelectorItemInfo("perfScorLevelDefine"));
			sic.add(new SelectorItemInfo("perfScorLevel"));
			EvaResultSummaryInfo evaResultSummaryInfo = ievaResultSummary.getEvaResultSummaryInfo(" where evaObj='" + evaObj + "'");
			String nodeGrade;
			if ((endWay == EndWayEnum.ENDPROCESS || endWay == EndWayEnum.ENDPERIOD) && !hasFinalGrade) {
				sumScore = null;
				nodeGrade = null;
			} else if (planInfo.getPerfRule().getId() != null) {
				String ruleId = planInfo.getPerfRule().getId().toString();
				WFNodeDefCollection wfNodeDefColl = GetEntityInfoUtils.getFinalGradeNodeColl(ctx, evaObj);
				if (null != wfNodeDefColl && wfNodeDefColl.size() > 0 && wfNodeDefColl.size() < 2) {
					if (isMatrixEvalu) {
						nodeGrade = WorkFlowEngine.getInstance().getMatrixWFNodeWholeGrade(ctx, evaObj, wfNodeDefColl.get(0));
					} else {
						nodeGrade = WorkFlowEngine.getInstance().getWFNodeWholeGrade(ctx, evaObj, wfNodeDefColl.get(0));
					}
				} else {
					nodeGrade = null;
				}

				if (StringUtils.isEmpty(nodeGrade) && null != sumScore) {
					nodeGrade = PerfWorkFlowUtils.getLevelByPerfScore(ctx, ruleId, Float.valueOf(sumScore), "1");
				}

				evaResultSummaryInfo.setGradeLevel(nodeGrade);
			}

			PerfEvaObjRejectionAreaCollection evaObjRejectionAreaColl = GetEntityInfoUtils.getPerfEvaObjRejectionAreaColl(ctx, evaObj);
			if (null != evaObjRejectionAreaColl && evaObjRejectionAreaColl.size() > 0) {
				int evaObjRejSize = evaObjRejectionAreaColl.size();

				for(int i = 0; i < evaObjRejSize; ++i) {
					if (evaObjRejectionAreaColl.get(i).getRejection() != null && evaObjRejectionAreaColl.get(i).getRejection().getValue().equals("100")) {
						sumScore = "0";
						String ruleId = planInfo.getPerfRule().getId().toString();
						nodeGrade = PerfWorkFlowUtils.getLevelByPerfScore(ctx, ruleId, Float.valueOf(sumScore), "1");
						evaResultSummaryInfo.setGradeLevel(nodeGrade);
						break;
					}
				}
			}
			// 202412
			if (null != newSumScore) {
				if(!StringUtils.isEmpty(cusGrade)) {
					evaResultSummaryInfo.setGradeLevel(cusGrade);  
					PerfScoreLevelInfo perfScorLevel = evaResultSummaryInfo.getPerfScorLevel();
					if(null != perfScorLevel) {
						FilterInfo filterInfo = new FilterInfo();
						filterInfo.getFilterItems().add(new FilterItemInfo("perfScoreLevel.id",perfScorLevel.getId().toString() , CompareType.EQUALS));
						filterInfo.getFilterItems().add(new FilterItemInfo("perfLevelName",cusGrade , CompareType.EQUALS));
//						SelectorItemCollection selectors = new SelectorItemCollection();
//						selectors.add(new SelectorItemInfo("id"));
						EntityViewInfo evi = new EntityViewInfo();
						evi.setFilter(filterInfo);
//						evi.setSelector(selectors);
						IPerfScorLevelDefine defIns = PerfScorLevelDefineFactory.getLocalInstance(ctx);
						PerfScorLevelDefineCollection sCollection = defIns.getPerfScorLevelDefineCollection(evi);
						if(sCollection.size()>0 ) {
							PerfScorLevelDefineInfo perfScorLevelDefineInfo = sCollection.get(0);
							evaResultSummaryInfo.setPerfScorLevelDefine(perfScorLevelDefineInfo);
						}
					}
				} 
				evaResultSummaryInfo.put("sumScore", PerfPortalUtils.roudUpRemainGiveDecimal(2, Float.valueOf(newSumScore)));
			} else {
				evaResultSummaryInfo.put("sumScore", (Object)null);
			}

			evaResultSummaryInfo = PerfWorkFlowUtils.setPerfscoreLevelForEvaresult(ctx, evaObj, evaResultSummaryInfo);
			if (!setFinalGrade) {
				evaResultSummaryInfo.setGradeLevel("");
				evaResultSummaryInfo.put("gradeLevel", "");
			}

			ievaResultSummary.updatePartial(evaResultSummaryInfo, sic);
		} else {
			this.createEvaResultSummary(ctx, evaObj);
		}
		//
		return newSumScore;
	}
	/****************************************ύɿ˽* over**************************************************/





}



